<?php
/**
 * WoWRoster.net UniAdmin
 *
 * WoWAce Module
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2002-2007 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: wowace.php 23 2007-06-14 06:07:59Z Zanix $
 * @link       http://www.wowroster.net
 * @package    UniAdmin
*/

if( !defined('IN_UNIADMIN') )
{
    exit('Detected invalid access to this file!');
}

if( $user->data['level'] == UA_ID_ANON )
{
	ua_die($user->lang['access_denied']);
}

include(UA_INCLUDEDIR . 'addon_lib.php');
require_once(UA_INCLUDEDIR . 'minixml.inc.php');
require_once(UA_INCLUDEDIR . 'xmlparser.class.php');


$ace_error = false;
$ace_file = UA_CACHEDIR . 'latest.xml';
$ace_url = 'http://files.wowace.com/latest.xml';




/**
 * WoWAce Addon Page Functions
 */

if( isset($_POST[UA_URI_OP]) )
{
	switch( $_POST[UA_URI_OP] )
	{
		case UA_URI_PROCESS:
			process_wowace_addons();
			break;
		
		case UA_URI_UPDATE_ALL:
			update_wowace_addons();
			break;
			
		case UA_URI_UPDATE_ONE:
			process_wowace_addons();
			$tpl->assign_vars(array(
				'L_MESSAGES' => $user->lang['messages'],
				'L_ERROR' => $user->lang['error'],
			) );
			//
			// Messages
			//
			if( !empty($uniadmin->messages) && is_array($uniadmin->messages) )
			{
				$tpl->assign_var('S_MESSAGE',true);
				foreach( $uniadmin->messages as $message )
				{
					$tpl->assign_block_vars('messages_row',
						array('TEXT'    => $message,
							'ROW_CLASS' => $uniadmin->switch_row_class(),
						)
					);
				}
			}
	
			//
			// Errors
			//
			if( !empty($uniadmin->error) && is_array($uniadmin->error) )
			{
				$tpl->assign_var('S_DEBUG',true);
				foreach( $uniadmin->error as $message )
				{
					$tpl->assign_block_vars('debug_row',
						array('TEXT'    => $message,
							'ROW_CLASS' => $uniadmin->switch_row_class(),
						)
					);
				}
			}
			$uniadmin->template_file = 'wowace_ajax.html';
			$tpl->set_filenames(array(
				'body' => $uniadmin->template_file
			) );
			// Send the HTTP headers
			$now = gmdate('D, d M Y H:i:s', time()) . ' GMT';
			@header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
			@header('Last-Modified: ' . $now);
			@header('Cache-Control: no-store, no-cache, must-revalidate');
			@header('Cache-Control: post-check=0, pre-check=0', false);
			@header('Pragma: no-cache');
			@header('Content-Type: text/html; charset=iso-8859-1');
			@header('X-UniAdmin-UpdateOne: 1');
			$tpl->display('body');
			$tpl->destroy();
			exit();
			break;

		case UA_URI_RELOAD:
			if( file_exists($ace_file) )
			{
				$try_unlink = unlink($ace_file);
				if( !$try_unlink )
				{
					$uniadmin->error(sprintf($user->lang['error_unlink'],$ace_file));
				}
			}
			break;
	}
}

// Assign template vars
$tpl->assign_vars(array(
	'L_WOWACE_ADDONS'   => $user->lang['get_wowace_addons'],
	'L_NOLIST'          => $user->lang['error_no_wowace_addons'],
	'L_NAME'            => $user->lang['name'],
	'L_DOWNLOAD'        => $user->lang['download'],
	'L_UPDATE_ALL'      => $user->lang['update_all'],
	'L_GO'              => $user->lang['go'],
	'L_NOTES'           => $user->lang['notes'],
	'L_VERSION'         => $user->lang['version'],
	'L_DATETIME'        => $user->lang['date_time'],
	'L_LASTUPDATED'     => $user->lang['last_updated'],
	'L_FORCERELOAD'     => $user->lang['force_reload'],
	'L_FORCERELOAD_TIP' => $user->lang['wowace_reload']
	)
);

if( !file_exists($ace_file) )
{
	$filelist = $uniadmin->get_remote_contents($ace_url);
	$uniadmin->message($user->lang['new_wowace_list']);

	$uniadmin->write_file($ace_file,$filelist);
	clearstatcache();
	$file_info = stat($ace_file);
	$tpl->assign_var('WOWACE_UPDATED',date($user->lang['time_format'],$file_info['9']) );
}
else
{
	clearstatcache();
	$file_info = stat($ace_file);
	if( ($file_info['9'] + (60 * 60 * $uniadmin->config['remote_timeout'])) <= time() )
	{
		// Download List
		$filelist = $uniadmin->get_remote_contents($ace_url);
		$uniadmin->message($user->lang['new_wowace_list']);

		$uniadmin->write_file($ace_file,$filelist);
		clearstatcache();
		$file_info = stat($ace_file);
		$tpl->assign_var('WOWACE_UPDATED',date($user->lang['time_format'],$file_info['9']) );
	}
	else
	{
		// Keep the old file
		$filelist = file_get_contents($ace_file);
		$tpl->assign_var('WOWACE_UPDATED',date($user->lang['time_format'],$file_info['9']) );
	}
}

if( !empty($filelist) )
{
	$tpl->assign_var('S_ACELIST', true);
	$tpl->assign_var('ONLOAD'," onload=\"initARC('ua_wowace','radioOn', 'radioOff','checkboxOn', 'checkboxOff');\"");

	$waaddons = array();
	if( function_exists('xml_parse') )
	{
		$xmlParser =& new XmlParser();
		$xmlParser->Parse(file_get_contents($ace_file));

		$items = $xmlParser->data['rss'][0]['child']['channel'][0]['child']['item'];

		foreach( $items as $item )
		{
			$title = $item['child']['title'][0]['data'];
			$description = ( isset($item['child']['description'][0]['data']) ? $item['child']['description'][0]['data'] : $title );
			$version = $item['child']['wowaddon:version'][0]['data'];
			$datetime = $item['child']['pubDate'][0]['data'];

			$waaddons[$title]['description'] = $description;
			$waaddons[$title]['version'] = $version;
			$waaddons[$title]['datetime'] = strtotime($datetime);

			$url = $item['child']['enclosure'][0]['attribs']['url'];
			$waaddons[$title]['url'] = ( !empty($url) ? str_replace('http://www.wowace.com/files', 'http://files.wowace.com', $url) : 'http://files.wowace.com/' . $title . '/' . $title . '.zip' );
		}
	}
	else
	{
		ua_die('php XML parsing functions are required for the WoWAce module');
	}

	uksort($waaddons, 'strnatcasecmp');

	$id = 0;
	foreach( $waaddons as $addon => $data )
	{
		$data['description'] = preg_replace('/\|c[a-f0-9]{2}([a-f0-9]{6})(.+?)\|r/i','<span style="color:#$1;">$2</span>',htmlentities($data['description']));
		// Assign template vars
		$tpl->assign_block_vars('addons_row', array(
			'ROW_CLASS'   => $uniadmin->switch_row_class(),
			'ID'          => 'addon_' . $id,
			'NAME'        => $addon,
			'DESC'        => $data['description'],
			'VERSION'     => $data['version'],
			'TIMESTAMP'   => date($user->lang['time_format'],$data['datetime'])
			)
		);
		$_SESSION['addon_' . $id] = $addon;
		$_SESSION['addon_' . $id . '_timestamp'] = $data['datetime'];
		$_SESSION['addon_' . $id . '_url'] = $data['url'];
		$id++;
	}
}
else
{
	$tpl->assign_var('S_ACELIST', false);
}

$uniadmin->set_vars(array(
	'page_title'    => $user->lang['title_wowace'],
	'template_file' => 'wowace.html',
	'display'       => true
	)
);

function process_wowace_addons( )
{
	global $uniadmin, $user, $db;

	foreach( $_POST as $addon => $dl )
	{
		if( $dl == 'on' )
		{
			$download[] = $addon;
		}
	}

	foreach( $download as $key => $addon )
	{
		$url = $_SESSION[$addon . '_url'];
		$timestamp = $_SESSION[$addon . '_timestamp'];
		$addon = $_SESSION[$addon];

		$addoncon = $uniadmin->get_remote_contents($url);
		$filename = UA_BASEDIR . $uniadmin->config['addon_folder'] . DIR_SEP . "$addon.zip";

		$write_temp_file = $uniadmin->write_file($filename,$addoncon,'w+');

		if( $write_temp_file === false )
		{
			$uniadmin->error(sprintf($user->lang['error_write_file'],str_replace('\\','/',$filename)));
		}
		else
		{
			$toPass = array();
			$toPass['name'] = $addon . '.zip';
			$toPass['type'] = 'application/zip';
			$toPass['tmp_name'] = $filename;

			if( is_readable($toPass['tmp_name']) )
			{
				$toPass['error'] = 0;
			}
			else
			{
				$toPass['error'] = 1;
			}
			$toPass['size'] = filesize($toPass['tmp_name']);
			process_addon($toPass);
			$sql = 'UPDATE `' . UA_TABLE_ADDONS . '` SET `time_uploaded` = \''.$timestamp.'\' WHERE `file_name` = \''.$toPass['name'].'\';';
			$result = $db->query($sql);
		}
	}
}

function update_wowace_addons()
{
	global $db, $uniadmin, $user, $tpl;
	
	$sql = 'SELECT * FROM `' . UA_TABLE_ADDONS . '` ORDER BY `name` ASC;';
	
	$result = $db->query($sql);

	// Set not scanned addons array
	$addon_in_db = array();
	$addonIndexByName = array();
	
	$i = 1;
	while ( isset( $_SESSION['addon_'.$i] ) ) {
		$addonIndexByName[$_SESSION['addon_'.$i]] = $i;
		$i++;
	}

	// Loop for every addon in database
	if( $db->num_rows($result) > 0 )
	{
		$tpl->assign_var('S_UPDATE_ALL', true);
		$addonsToUpdate = array();
		$addonSQLIds = array();
		while( $row = $db->fetch_record($result) )
		{
			$addon = substr( $row['file_name'], 0, -4 );
			if ( isset( $addonIndexByName[$addon] ) ) {
				$index = $addonIndexByName[$addon];
				if ( $row['time_uploaded'] == $_SESSION['addon_' . $index . '_timestamp'] ) {
					$addonSQLIds[] = $row['id'];
				}
				else {
					$url = $_SESSION['addon_'.$index. '_url'];
					$tpl->assign_block_vars('addons_to_update_row', array(
						'NAME' =>  $addon,
						'URL' =>  $url,
						'INDEX' =>  'addon_'.$index
					) );
				}
			}
			else {
				//$uniadmin->message(sprintf($user->lang['not_wowace_addon'],$row['name']));
			}
		}
	}
	
	//echo '<pre>'.print_r( $_SESSION, true ).'</pre>'."\n";
}
